\section{Free and Finitely Generated Modules}
\begin{lem}
  Let $M$ be an $R$-module, $(M_i)$ a family of submodules of $M$. Then the intersection $\bigcap_i M_i$ and the sum
  \[
  \sum_{i}M_i \defined
  \lset
  \sum_i m_i \ssp
  \begin{tabular}{@{}l@{}}
    $m_i\in M_i$,\\
    $m_i\neq 0$ for only finitely many $i$.
   \end{tabular}
   \rset
  \]
  are submodules of $M$.
\end{lem}
\begin{proof}
  Ommited.
\end{proof}
\begin{defn}
\leavevmode
\begin{enumerate}
  \item Let $M_1,M_2\sse M$ be submodules of an $R$-module $M$. If $M_1\cap M_2 = \lset 0\rset$ and $M_1+M_2 = M$, we write $M_1\oplus_{\text{int}} M_2 = M$. This construction is called the \emph{(internal) direct sum} of $M_1$ and $M_2$.
  \item Let $(M_i)$ be a family of $R$-modules. Then the \emph{product}\index{product!of $R$-modules} of the $\lset M_i\rset$ is defined as the cartesian product $\prod_i M_i$, with component-wise addition and scalar multiplication.
  \item Let $(M_i)$ be a family of $R$-modules. Then the \emph{direct sum} (or \emph{coproduct})\index{direct sum}\index{coproduct!of $R$-modules} $\lset M_i\rset $ is defined as the submodule
  \[
  \bigoplus_i M_i \defined \lset
  (m_i) \ssp
  \begin{tabular}{@{}l@{}}
    $(m_i)\in \prod_i M_i$,\\
    $m_i\neq 0$ for only finitely many $i$.
   \end{tabular}
   \rset \sse \prod_i M_i.
  \]
\end{enumerate}
\end{defn}
\begin{mrem}
  \leavevmode
  \begin{enumerate}
    \item If we regard two submodules $M_1,M_2\sse M$ of an $R$-module $M$ with $M_1\oplus_{\text{int}}M_2 = M$ as $R$-modules, then $M_1\oplus M_2 \cong M = M_1\oplus_{\text{int}}M_2$. So we will not distinguish further between the two notions.
    \item If $(M_i)$ is a finite family of $R$-modules, then the product and direct sum of the $M_i$ are equal.
    \item The product of a family $(M_i)$ is indeed a product in the category $\rmod$. The coproduct of a family $(M_i)$ is indeed a coprodcut in the category $\rmod$. So $R$-$\modc$ is an abelian category.
  \end{enumerate}
\end{mrem}
\begin{defn}
  Let $\lset x_i \rset$ be a family of elements in an $R$-module $M$.
  \begin{enumerate}
    \item We say $\lset x_i\rset$ is a \emph{generating system}\index{generating system!of a module} of $M$ if every $x\in M$ can be written as a finite linear combination of some of the $x_i$.
    \item We define the subspace $\lin \lset x_i\rset$ \emph{generated by $\lset x_i\rset$} as
    \[
    \lin \lset x_i \rset \defined
    \lset
    \sum a_i x_i \ssp
    \begin{tabular}{@{}l@{}}
      $a_i \in R$,\\
      $a_i\neq 0$ for only finitely many $i$.
     \end{tabular}
     \rset.
     \]
    \item We say $\lset x_i\rset$ is \emph{linearly independent}\index{linearly independent subset} if for all tuples $(x_1,\hdots,x_n)$ of elements from $\lset x_i\rset$ there are no $a_i\in R$ such that
    \[
    a_1x_1+\hdots+a_nx_n = 0.
    \]
    \item We say $\lset x_i\rset$ is a \emph{basis}\index{basis! of a module} if it is a linearly independent generating system.
    \item $M$ is a \emph{free $R$-module}\index{free! module}\index{module!free} if there is an index set $I$ such that $M \cong \bigoplus_{i\in I}R$.
    \item $M$ is a \emph{finite-free $R$-module} if there is a finite index set $I$ such that $M \cong \bigoplus_{i \in I}R$.
    \item $M$ is a \emph{finitely generated $R$-module}\index{finitely generated! as module}\index{module!finitely generated} if $M$ has a finite generating system.
  \end{enumerate}
\end{defn}
\begin{mrem}
  Let $M$ be an $R$-module.
  \begin{enumerate}
    \item $M$ is free if and only if $M$ has a basis.
    \item $M$ is finitely generated if and only if there is a surjective $R$-linear map $R^n\to M$ for a $n\geq 0$.
    \item $M$ is finite-free if and only if it is finitely generated and free.
  \end{enumerate}
\end{mrem}
\begin{mdefn}
  Let $M$ be an $R$-module. We say $M$ is \emph{finitely presented} or that $M$ is an \emph{$R$-module of finite presentation} if there are integers $n,m$ and an exact sequence of the form
  \[
  \begin{tikzcd}[cramped, column sep = small]
    R^m\ar{r}&
    R^n\ar{r}&
    M\ar{r}&
    0
  \end{tikzcd}
  \]
\end{mdefn}
\begin{mexample}
\leavevmode
\begin{enumerate}
  \item If $M$ is finitely presented then $M$ is already finitely generated.
  \item The converse is in general not true: The sequence $R^m\to R^n\to M$ being exact is equivalent to saying that $R^m\to R^n$ is a kernel for the projection $R^n \to M$. Consider now any non-noetherian ring and $I\sse R$ an ideal which is not finitely generated. Then $R/I$ is not finitely presented. As a concrete example, there is no presentation for $k[\polvariable_1,\hdots]/\genby{\polvariable_1,\hdots}$.
\end{enumerate}
\end{mexample}
\begin{mrem}
  The alternative characterizations of a basis, as known from linear algebra for vector spaces, does not hold for general modules: Consider $R=\zz$ and $M = \zz$. Then $\zz$ has a basis given by $\lset 1\rset$. However, the subset $\lset 2,3\rset$ is also linear independet, and the subset $\lset 2\rset$ does not generate all of $\zz$.
\end{mrem}
\begin{rem}\label{5:free-rmodules}
Let $M$ be a free $R$-module with basis $\lset x_{i}\rset_{i \in I}$. Let $M'$ be another $R$-module and $\lset y_{i}\rset_{i\in I}$ a subset of $M'$. Then there is a unique $R$-linear map $f:M\to M'$ such that the diagram
\[
\begin{tikzcd}
  M\ar[dashed]{r}[above]{\exists ! f } &
  M'\\
  \lset x_{i}\rset_{i\in I}\ar[hookrightarrow]{u} \ar{ur}[below right]{\overline{f}}&
\end{tikzcd}
\]
commutes. Here, the map of sets $\overline{f}:\lset x_{i}\rset_{i\in I}$ is given by $\overline{f}(x_{i}) \defined y_{i}$ for all $i \in I$. This is called the \emph{universal property of a free module}.\par
If $M'$ is a finitely generated $R$-module, then in particular there is a surjective map $R^n \to M'$.\par
This gives a functor $F:\setc \to R$-$\modc$, which associates to each set $M$ the free module $F(M)$ and to each map of sets $f:M\to M'$ the $R$-linear map which is $f$ on basis elements. There is also a forgetful functor $G:R$-$\modc\to \setc$ which simply forgets the $R$-linear structure on an $R$-module $N$. This pair is an adjunction.
\end{rem}
\begin{example}
  \leavevmode
  \begin{enumerate}
    \item For $R = \zz$ and $M = \zz/p\zz$, $M$ is not a free $\zz$-module, as every element has torsion.
    \item For $R = \zz$ and $M = \rationals$, $M$ is not finitely generated as $\zz$-module.
  \end{enumerate}
\end{example}
\begin{defn}
  Let $M$ be an $R$-module and $I\sse R$ an ideal. We define the submodule $IM$ as
  \[
  IM \defined \lin \lset am \ssp a\in I, m\in M\rset.
  \]
\end{defn}
\begin{mlem}
  Let $M$ be an $R$-module and $I\sse R$ an ideal. Then $M/IM$ has the structure of an $R/I$-module.
\end{mlem}
\begin{lem}
  Let $M$ be an $R$-module such that
  \[
  R^n \cong M \cong R^m
  \]
  for some $n,m\in \nn$. Then $m=n$ follows.
\end{lem}
\begin{proof}
  Let $\idm\sse R$ be a maximal ideal, so $R/\idm$ is a field. Then
  \begin{align*}
  \dim_{R/\idm R} M/\idm M &= \dim_{R/\idm R} R^n/\idm R^n\\
                          &= \dim_{R/\idm R} \left(R/\idm R\right)^n\\
                          &= n,
  \end{align*}
  so $n$ is uniquely determined.
\end{proof}
\begin{rem}[Linear Algebra for Modules]
For $n,m\in \nn$, we can identify $\hom_R(R^n,R^m)$ with the set $\mat(n\times m, R)$ of $n\times m$-matrices with entries in $R$. For an endomorphism $f: R^n \to R^n$, we have that $f$ is an isomorphism if and only if its associated matrix is invertible. \par
Using the Leibniz formula, we define the \emph{determinant}\index{determinant} of a $n\times n$ matrix $A = (a_{i,j}) \in \mat\left(n\times n, R\right)$ as
\[
\det A \defined
\sum_{\sigma \in S_n} \sgn (\sigma) a_{1,\sigma(1)}\hdots a_{n,\sigma(n)}.
\]
Using the determinant, we associate to every matrix $A = (a_{i,j}) \in \mat(n\times n,R)$ the \emph{adjugate matrix} $\adju M$, which is defined as
\[
\left(\left(\adju A\right)_{i,j}\right) \defined \left(-1\right)^{i+j}\det A_{j,i}
\]
where the matrix $A_{j,i}\in \mat\left((n-1)\times (n-1),R\right)$ is obtained from $A$ by removing the $j$-th row and the $i$-th column. It then holds that
\[
A\adju A = \left(\adju A\right) A = \det A \cdot E_n
\]
where $E_n$ denotes the $n\times n$ unit matrix. As the determinant stays multiplicative for matrices with entries in an arbitrary ring, we have that a matrix with entries in $R$ is invertible if and only if its determinant is a unit in $R$.
\end{rem}

\begin{prop}[Cayley-Hamilton for Modules\index{Theorem!Cayley-Hamilton}]\label{5:cayley-hamilton}
Let $M$ be a finitely generated $R$-module, $I\sse R$ an ideal and $f:M\to M$ an endomorphism, such that $f(M) \sse IM$. Then there is a monic polynomial $p = \sum_{i=0}^n a_i \polvariable^i\in R[\polvariable]$ such that $a_i \in I$ for $i\neq n$ and $p(f) = 0$ holds.
\end{prop}
\begin{proof}
  Let $\lset m_1,\hdots, m_n\rset$ be a generating set for $M$. Then $f(m_i)\in IM$ for all $1\leq i \leq n$, and so there are $a_{ij}\in I$ for $1\leq i,j\leq n$ such that
  \begin{equation}\tag{$\ast$}\label{5:cayley-hamilton-f-cond}
  f(m_j) = \sum_{i=1}^n a_{ij}m_i
  .
  \end{equation}
   \par
  By \cref{4:r[x]-modules-and-endos}, we can regard $M$ as an $R[\polvariable]$-module, with the action $\polvariable x \defined f(x)$ for all $x\in M$. The condition \eqref{5:cayley-hamilton-f-cond} then reads as
  \[
  \sum_{i=0}^n \left(\polvariable\delta_{ij}-a_{ij}\right) m_j  = 0~\text{ for all }1\leq j \leq n.
  \]
  Consider now the matrices $A\defined \left(\left(\polvariable\delta_{ij}-a_{ij}\right)_{i,j}\right)$ and $B\defined \adju A$. Then $BA =  \det A \cdot E_n$, and hence
  \[
  \det \left( \left( \polvariable\delta_{ij}-a_{ij}\right)_{i,j} \right) \left(m_j\right) = 0.
  \]
  The claim follows for the polynomial $p \defined \det \left( \left( \polvariable\delta_{ij}-a_{ij}\right)_{i,j} \right)$. (That $p$ is monic and the non-leading coefficients are in $I$ follows from the Leibniz-formula.)
\end{proof}

\begin{lem}
  Let $M$ be a finitely generated $R$-module and $f:M\to M$ a surjective $R$-linear map. Then $f$ is already an isomorphism.
\end{lem}
\begin{proof}
  As in \cref{4:r[x]-modules-and-endos}, we consider $M$ as an $R[\polvariable_1]$ module. Consider the ideal $I \defined \genby{\polvariable_1}\sse R[\polvariable_1]$. As $f$ is surjective, $IM = M$ follows.
  By \cref{5:cayley-hamilton} (for the endomorphism $\id: M\to M$), there is a polynomial $p = \polvariable_2^n+a_{n-1}\polvariable_2^{n-1}+\hdots + a_0\in R[\polvariable_1][\polvariable_2]$ such that $p(\id) = 0$. So there is a polynomial $q\in R[\polvariable_1]$ with
  \[
  \id = \polvariable_1q(\polvariable_1).
  \]
  Evaluating at $f$ gives the invese.
\end{proof}

We will now state and prove two version of \emph{Nakayama's Lemma}:
\begin{lem}[Nakayama - \glqq the general one\grqq\index{Nakayama Lemma}\index{Lemma!Nakayama}]\label{5:nakayama-general}
  Let $M$ be a finitely generated $R$-module and $I\sse R$ an ideal with $IM = M$.
  \begin{enumerate}
    \item There is an $a\in I$ such that $am = m$ for all $m\in M$.
    \item There is a $x\in R$ such that $1-x\in I$ and $xM = 0$.
  \end{enumerate}
\end{lem}
\begin{proof}
  \leavevmode
  \begin{enumerate}
    \item Apply \cref{5:cayley-hamilton} to $\id:M\to M$. Then there are $a_0,\hdots,a_{n-1}\in I$ such that
    \[
    \id = \left(-(a_{n-1}+\hdots+a_0)\right)\id.
    \]
    As $I$ is an ideal, $-(a_{n-1}+\hdots+a_0)\in I$.
    \item For $x\defined 1 + a_{n-1}+\hdots+a_0$, where the $a_0,\hdots,a_{n-1}$ are choosen as in the proof of i), the claim follows.
  \end{enumerate}
\end{proof}
\begin{lem}[Nakayama - \glqq the classical one\grqq]\label{5:nakayama-classical}
  Let $M$ be a finitely generated $R$-module, and $I\sse \jacr R$ an ideal. Then $IM = M$ if and only if $M=0$.
\end{lem}
\begin{proof}
  If $M=0$, then $IM =0$. If $IM = M$, then by \cref{5:nakayama-general} there is an $x\in R$ such that $1-x\in \jacr R$.
  Now by \cref{2:jacobson-units}, $x=1-\left(1-x\right)\in R\unts$. But this implies $1m = 0$ for all $m\in M$. So $M = 0$.
\end{proof}

\begin{mlem}\label{5:quotient-of-fg}
  Let $M$ be a finitely generated $R$-module, and $M'$ a submodule. Then $M/M'$ is again finitely generated.
\end{mlem}
\begin{proof}
  By \cref{5:free-rmodules}, there is a surjective map $R^n\to M$. Extend this to a surjective map $R^n\to M \to M/M'$.
\end{proof}
\begin{mrem}
  It is in general not true that submodules of finitely generated modules are again finitely generated: Let
  \[
  I_1\ssne I_2\ssne \hdots \ssne R
  \]
  be a strictly increasing chain of ideals in a ring $R$. Then the ideal
  \[
  I \defined \bigcup_{i=1}^{\infty}I_i
  \]
  is not finitely generated as an $R$-module.\par

    $I$ is an ideal, since it is the union over a chain of ideals. Furthermore, $I\neq R$, since there is no ideal $I_i$ with $1\in I_i$.
    If there were $f_1,\hdots,f_n$ such that $I = \genby{f_1,\hdots,f_n}$ then there would be a $m$ such that $f_1,\hdots,f_n\in I_m$. But then $I\sse I_m \ssne I_{m+1}\ssne I$, which is not possible. So $I$ is not a finitely generated $R$-module.
  \par
  So consider now the polynomial ring in infintely many variables over a ring $R\neq 0$, $R'\defined R[\polvariable_1,\polvariable_2,\hdots]$. Then the chain of ideals
  \[
  \genby{\polvariable_1}\ssne \genby{\polvariable_1,\polvariable_2}\ssne \hdots \ssne R'
  \]
  is strictly increasing, so the submodule $\genby{\polvariable_1,\polvariable_2,\hdots}$ is not finitely generated as an $R$-module.
\end{mrem}
\begin{cor}\label{5:submodule-plus-jacobson-is-whole-ring}
  Let $M$ be a finitely generated $R$-module, $N\sse M$ a submodule and $I\sse \jacr R$ such that
  \[
  M = IM + N.
  \]
  Then $M = N$ holds.
\end{cor}
\begin{proof}
  We have
  \begin{align*}
    I(M/N)
    &= (IM+N)/N\\
    &= M/N.
  \end{align*}
  Then by \cref{5:quotient-of-fg} and \cref{5:nakayama-classical}, $M/N=0$ follows, which implies $M=N$.
\end{proof}

\lec
